#!/usr/bin/python
import busio
import board
import digitalio
import adafruit_mcp3xxx.mcp3008 as MCP
import Adafruit_DHT
import time
import RPi.GPIO as GPIO
GPIO.cleanup()
GPIO.setmode(GPIO.BCM)
GPIO.setup(17, GPIO.OUT)
GPIO.setup(27, GPIO.OUT)
GPIO.setup(22, GPIO.OUT)
GPIO.output(17, GPIO.HIGH)
GPIO.output(22, GPIO.HIGH)
GPIO.output(27, GPIO.HIGH)
from time import sleep
from adafruit_mcp3xxx.analog_in import AnalogIn
# create the spi bus
spi = busio.SPI(clock=board.SCK, MISO=board.MISO, MOSI=board.MOSI)
# create the cs (chip select)
cs = digitalio.DigitalInOut(board.D5)
# create the mcp object
mcp = MCP.MCP3008(spi, cs)
# create an analog input channel on pin 0
chan = AnalogIn(mcp, MCP.P0)
dryness_val=((chan.value)-31000)/32000*100
#Sets the Dryness Calibration percentage. Take the value read at the channel (pin0 on chip)
#take the range from dryiest point of soil to fully submerged in water. subtract the submerged value.
#divide by the range and multiply by 100 for percentage
localtime = time.asctime(time.localtime(time.time()) )
time_start = time.asctime(time.localtime(time.time()) )

fantime=time.asctime(time.localtime(time.time()) )

lightsoff=time.asctime(time.localtime(time.time()) )

def setup():
    GPIO.cleanup()
    GPIO.setmode(GPIO.BCM)
    GPIO.setup(17, GPIO.OUT)
    GPIO.setup(27, GPIO.OUT)
    GPIO.setup(22, GPIO.OUT)
    GPIO.output(17, GPIO.HIGH)
    GPIO.output(22, GPIO.HIGH)
    GPIO.output(27, GPIO.HIGH)



#read and print function with selected information regarding current sensor values
def read_report():
    # create the spi bus
    spi = busio.SPI(clock=board.SCK, MISO=board.MISO, MOSI=board.MOSI)
# create the cs (chip select)
    cs = digitalio.DigitalInOut(board.D5)
# create the mcp object
    mcp = MCP.MCP3008(spi, cs)
    chan = AnalogIn(mcp, MCP.P0)
    dryness_val=(chan.value-27000)/27000*100
    humidity, temperature = (Adafruit_DHT.read_retry(11,25))#GPIO25
    if temperature != None:
        temperature=(temperature*(1.8)+(32))    

    if temperature != None:
        print ("Humidity = {} %; Temperature = {} F".format (humidity, round(temperature,1)))
    print('Soil Dry: ', round(dryness_val,1),str('%'))
    print('Raw Value Soil Moisture: ', chan.value)
    #print('Soil Sensor Voltage: ' + str(chan.voltage) + 'V')
    
    
def fans_ON():
    GPIO.output(22, GPIO.LOW)
    print('Fans ON')    
    fantime=time.asctime(time.localtime(time.time()) )

def fans_OFF():
    GPIO.output(22, GPIO.HIGH)
    print('Fans OFF')
    
    

def pump_ON():
    GPIO.output(27, GPIO.LOW)
    print('Pump Turning ON')
    sleep(4)
    GPIO.output(27, GPIO.HIGH)
    print('Pump Turning OFF')
       
def lights_OFF():
    GPIO.output(17, GPIO.HIGH)
    print('Lights Are OFF')

    
def lights_ON():
    GPIO.output(17, GPIO.LOW)
    print('Lights Are ON')
    
    
def time_info():
    localtime = time.asctime( time.localtime(time.time()) )
    
    print ('Current Time :', localtime)
    print ('The Power has been on since:',time_start)
    


    
    
    

